<script lang="ts">
  import triangleDown from "@iconify-icons/codicon/triangle-down"
  import triangleRight from "@iconify-icons/codicon/triangle-right"
  import type { ComponentType, SvelteComponentTyped } from "svelte"

  import type { Access } from "$lib/access"

  export let access: Access | undefined = undefined
  /// Show/hide frame of root array or object.
  export let frame = true
  export let open = false
  export let summarize: (
    access: Access | undefined,
    value: unknown,
  ) => ComponentType<SvelteComponentTyped> | string | undefined = () =>
    undefined
  export let value: unknown

  function toggle() {
    open = !open
  }
</script>

{#if value === undefined}
  <span>undefined</span>
{:else if value === null}
  <span>null</span>
{:else if typeof value === "number"}
  <span>{value}</span>
{:else if typeof value === "string"}
  <span>{JSON.stringify(value)}</span>
{:else if Array.isArray(value)}
  {@const length = value.length}
  {#if frame}
    {@const summary = summarize(access, value)}
    {#if length === 0}
      {#if summary === undefined}
        <span>[ <i class="text-secondary">length: {length}</i> ]</span>
      {:else if typeof summary === "string"}
        <span>[ <i class="text-secondary">{summary}</i> ]</span>
      {:else}
        <span>[ <svelte:component this={summary} {access} {value} /> ]</span>
      {/if}
    {:else}
      <span
        class="cursor-pointer"
        on:click={toggle}
        on:keyup={toggle}
        role="button"
      >
        <iconify-icon
          class="inline-block"
          icon={open ? triangleDown : triangleRight}
          inline
        />
        {#if summary === undefined}
          <span>[ <i class="text-secondary">length: {length}</i> ]</span>
        {:else if typeof summary === "string"}
          <span>[ <i class="text-secondary">{summary}</i> ]</span>
        {:else}
          <span>[ <svelte:component this={summary} {access} {value} /> ]</span>
        {/if}
      </span>
    {/if}
  {/if}
  {#if (!frame || open) && length > 0}
    <ol class:pl-4={frame}>
      {#each value as item, index}
        <li>
          <svelte:self
            access={{ access, key: index, parent: value }}
            {summarize}
            value={item}
          />
        </li>
      {/each}
    </ol>
  {/if}
{:else if typeof value === "object"}
  {@const length = Object.keys(value).length}
  {#if frame}
    {@const summary = summarize(access, value)}
    {#if length === 0}
      {#if summary === undefined}
        <span>{"{"} <i class="text-secondary">length: {length}</i> {"}"}</span>
      {:else if typeof summary === "string"}
        <span>{"{"} <i class="text-secondary">{summary}</i> {"}"}</span>
      {:else}
        <span
          >{"{"}
          <svelte:component this={summary} {access} {value} />
          {"}"}</span
        >
      {/if}
    {:else}
      <span
        class="cursor-pointer"
        on:click={toggle}
        on:keyup={toggle}
        role="button"
      >
        <iconify-icon
          class="inline-block"
          icon={open ? triangleDown : triangleRight}
          inline
        />
        {#if summary === undefined}
          <span>{"{"} <i class="text-secondary">length: {length}</i> {"}"}</span
          >
        {:else if typeof summary === "string"}
          <span>{"{"} <i class="text-secondary">{summary}</i> {"}"}</span>
        {:else}
          <span
            >{"{"}
            <svelte:component this={summary} {access} {value} />
            {"}"}</span
          >
        {/if}
      </span>
    {/if}
  {/if}
  {#if (!frame || open) && length > 0}
    <ul class:pl-4={frame}>
      {#each Object.entries(value) as [itemKey, itemValue]}
        <li>
          {itemKey}: <svelte:self
            access={{ access, key: itemKey, parent: value }}
            {summarize}
            value={itemValue}
          />
        </li>
      {/each}
    </ul>
  {/if}
{:else}
  <span>TODO {typeof value}: {JSON.stringify(value)}</span>
{/if}
